#include <stdio.h>
#include "hzk24.h"

byte* hzk24::buffer = NULL;
hzfont* hzk24::fonts = NULL;
int hzk24::fontslength = 0;


hzk24::hzk24()
{
	int i, j;
	for (i = 0; i < 24; i++)for (j = 0; j < 24; j++)
		zhi24[i][j] = 0;
	for (i = 0; i < 500; i++)for (j = 0; j < 500; j++)
		zhi[i][j] = 0;
	if (!buffer)
		create();
}


hzk24::~hzk24()
{
}

extern int hanziku24length;
extern unsigned char hanziku24[];

void hzk24::create()
{
	if (buffer)return;
	int filelength;
	filelength = hanziku24length;
	buffer = (byte*)hanziku24;
	fonts = (hzfont*)buffer;
	fontslength = filelength / 74;
}

bool hzk24::getzhi24(const char* s)
{
	if (!fontslength)return false;
	byte b1, b2;
	b1 = (byte)s[0];
	b2 = (byte)s[1];
	unsigned short hzdm;
	if (b1 > 128)
		hzdm = b1 * 256 + b2;// ΪȫǺ
	else hzdm = b1; // Ϊַ
	int begin, end, half;
	unsigned short halfdm; // һ봦ĺִ
	begin = 0;
	end = fontslength - 1;
	bool founded = false;
	while (true)
	{
		if (end - begin <= 1) {// ֻ1
			halfdm = fonts[begin].hzbm;
			if (halfdm == hzdm) {
				half = begin;
				founded = true;
				break;
			}
			halfdm = fonts[end].hzbm;
			if (halfdm == hzdm) {
				half = end;
				founded = true;
				break;
			}
			break; // ûз
		}
		half = (begin + end) / 2;
		halfdm = fonts[half].hzbm;
		if (halfdm == hzdm) {
			founded = true;
			break;
		}
		else if (halfdm > hzdm) {
			end = half;
			continue;
		}
		if (begin == end)break;
		begin = half;
	}
	int i, j;
	if (!founded) {// ҲʲôҲʾ
		for (i = 0; i < 24; i++)for (j = 0; j < 24; j++) {
			zhi24[i][j] = false;
		}
		return false;
	}
	for (i = 0; i < 24; i++)for (j = 0; j < 24; j++) {
		if ((0x80 >> i % 8)&fonts[half].font[i / 8 + j * 3])
			zhi24[i][j] = true;
		else
			zhi24[i][j] = false;
	}
	return true;
}

void hzk24::getzhi(const char* s, int xsize, int ysize)
{
	// Ȳ24
	if (!fontslength)return;// ղûгɹ뺺ֿʲôҲ
	if (xsize < 14 || xsize >= 500 || ysize < 14 || ysize >= 500)throw "error for xsize or ysize";// ַߴ粻ܹС14ʹ500
	getzhi24(s);
	int i, j;
	double x, y;
	int ix, iy;
	static bool zhib[500][500];
	for (i = 0; i < xsize; i++)for (j = 0; j < ysize; j++) {
		zhi[i][j] = zhib[i][j] = false;
	}
	for (ix = 0; ix < 24; ix++)for (iy = 0; iy < 24; iy++) {
		x = ix * xsize / 24.0;
		y = iy * ysize / 24.0;
		i = (int)(x + 0.5);
		j = (int)(y + 0.5);
		if (zhi24[ix][iy])
			zhi[i][j] = zhib[i][j] = true;
	}
	for (i = 0; i < xsize; i++)for (j = 0; j < ysize; j++) {
		x = i * 24.0 / xsize;
		y = j * 24.0 / ysize;
		ix = (int)(x + 0.5);
		iy = (int)(y + 0.5);
		if (zhi24[ix][iy])
			zhi[i][j] = zhib[i][j] = true;
	}
	for (i = 1; i < xsize - 1; i++)for (j = 1; j < ysize - 1; j++) {
		if ((zhib[i-1][j-1] && zhib[i+1][j+1])|| (zhib[i-1][j+1]&&zhib[i+1][j-1])) {
			zhi[i][j] = true;
			//zhi[i - 1][j - 1] = zhi[i][j - 1] = zhi[i + 1][j - 1] = zhi[i - 1][j] = zhi[i + 1][j]
			//	= zhi[i - 1][j + 1] = zhi[i][j + 1] = zhi[i + 1][j + 1] = true;
		}
	}
}
